From fd8284b51cd029be03e02c5b419ce3f3c096af6d Mon Sep 17 00:00:00 2001
From: nbv <nbv@opencascade.com>
Date: Wed, 18 Jan 2017 12:18:24 +0300
Subject: [PATCH] 0028211: Modeling Algorithms - Boolean fuse operation
 produces incorrect result

The reason of the regression is a mistake while classification of some face (created by Boolean algorithm and looks like thin ring) as hole. In the fix, another algorithm for classification is used.

Additional corrections:

1. Classes IntTools_FClass2d and BRepTopAdaptor_FClass2d have been joined to the single class BRepTopAdaptor_FClass2d (IntTools_FClass2d has been eliminated but now, BRepTopAdaptor_FClass2d is configured as current version of IntTools_FClass2d).

2. Interface (and algorithms) of following classes have been changed: BRepClass3d_Intersector3d, BRepClass_FClass2dOfFClassifier, BRepClass_FClassifier, BRepClass_FaceClassifier, BRepClass_FaceExplorer, BRepClass_FacePassiveClassifier, BRepClass_Intersector, BRepTopAdaptor_FClass2d, CSLib_Class2d, Geom2dHatch_Classifier, Geom2dHatch_Elements, Geom2dHatch_FClass2dOfClassifier, Geom2dHatch_Intersector, TopClass_FaceClassifier, BRepTopAdaptor_TopolTool.

3. Changes in BOPAlgo_PaveFiller::PerformEE() and BOPAlgo_PaveFiller::PerformEF() methods (see BOPAlgo_PaveFiller_3.cxx and BOPAlgo_PaveFiller_5.cxx files): The algorithm of the vertex tolerance computation has been corrected in order to make new vertex cover regions with irregularities (such as Self-intersection).

4. Now, every segment returned by BRepClass_FaceExplorer and/or Geom2dHatch_Elements has some weight, which shows to what extent we can trust this segment in classification process. As result, the classificator returns data obtained from the most reliable segment. These weight are stored in BRepClass_FaceExplorer::RayInfo::myWeight and Geom2dHatch_Elements::RayInfo::myWeight variables.

5. New classes TopClass_RayInfo (describes classification ray joined the classification point with some point in the edge of classified face), TopClass_GeomEdge and TopClass_GeomVertex (store geometrical structure of the edges including pseudo-edges and their vertices) have been created.

6. Method BRepTopAdaptor_FClass2d::PerformInfinitePoint() has been corrected in order to use another (than on the MASTER) point for classification.

7. Method IntTools_EdgeEdge::ComputeLineLine(...) returns intersection point even if the edges have shared vertex. Earlier, it did not it.

8. Creation of pseudo-edges in order to cover gaps in geometrically not-closed (in 2D-space) faces. These face are considered as valid if this gap is covered by some vertex. However, classifier cannot work with "covering vertices". Therefore, new feature (pseudo-edge) has been created. In fact, pseudo-edge is line segment in 2D-space joined two not-closed points.

9. BRepClass_Edge class has been deleted.

10. Check if the section curve cannot be converted to TopoDS_Edge has been added in BOPAlgo_PaveFiller::MakeBlocks() method.

11. Algorithms using face-classifier have been adjusted in order to force them send 3D-tolerance instead of 2D one. I.e. if 3D-representation of classified 2D-point lies ON the edge of the face (the distance from it to the edge is less than the edge tolerance) then it is possible to obtain IN/OUT (not ON) status as result of classification in case when the face tolerance is significantly lesser than the edge tolerance.

12. Since now, following classes apply 3D-tolerance intead of 2D (were applied earlier): Adaptor3d_TopolTool::Classify(...), Adaptor3d_TopolTool::IsThePointOn(...), BRepClass_FClass2dOfFClassifier::Reset(...), BRepClass_FClassifier::BRepClass_FClassifier(...), BRepClass_FClassifier::Perform(...), BRepClass_FaceClassifier::BRepClass_FaceClassifier(...), BRepClass_FaceClassifier::Perform(...), BRepClass_FacePassiveClassifier::Reset(...), BRepClass_Intersector::Perform(...), BRepTopAdaptor_FClass2d::BRepTopAdaptor_FClass2d(...), BRepTopAdaptor_FClass2d::TestOnRestriction(...), BRepTopAdaptor_TopolTool::Classify(...), BRepTopAdaptor_TopolTool::IsThePointOn(...).

13. Modify BRepCheck to report Unorientable shape if a face is classified as UNKNOWN.

14. Do not use vertices tolerances at the edge domain ends in 2d intersection.

15. Check whether the polygonal classifier (CSLib_Class2d) will be able to return correct result has been amended. Namely, CSLib_Class2d is forbidden for using in case of not-closed polygon, self-intersected polygon etc.

16. New method GeomLib::LocalGeometry() has been added. This method returns tangent, normal and curvature in the point of 2D-curve.

17. New DRAW-command "ishole" has been created in BOPTest_LowCommands.cxx file. This command checks if the material of the face is inside (not hole) or outside (hole) of wire enclosed region.

18. New DRAW-command "polyclassify" has been created in BOPTest_LowCommands.cxx file. This command checks if the source point is IN/OUT/ON of the given polygon. See DRAW-help for detail information.

19. Interfaces of DRAW-commands "b2dclassify", "b2dclassifx" have been changed. See helps to the new commands.

20. New DRAW-commands returning the resolutions of curve/surface have been created (see "curvresolution" and "surfresolution"). Non-regression test cases have been created for these commands in geometry/props grid.

21. New DRAW-command "2dpolyline" has been created. It allows creating polygon in 2D-space. Please see help for detailed information.

22. Creation of test cases for issues #28211, #28800 and #29203.

23. New testgrid "lowalgos" has been created. This testgrid is planed to collect all test cases with low-level algorithms (exthrema, intersector, classifier etc.)

24. Code refactoring and documenting.

-----------------------------------------------------------------

Correction of test cases according to their new behavior.

1. tests/blend/tolblend_simple/C1

The reason while this test has become failure is described in the test case tests/lowalgos/classifier/bug28211_19. Earlier, the classifier returned IN-status. Now, it returns ON. And ON-status is correct result.

2. tests/bugs/heal/bug22919

The face contains only two edges, i.e. not-closed (see example in bug22919_FaceKO2.PNG and bug22919_FaceKO4.PNG attached pictures). This gap is covered by pseudo-edges.

3. tests/bugs/modalg_6/bug25908

The reason of changes is explained in tests/lowalgos/classifier/bug28211_20. Earlier, the classifier returned OUT-status. Now, it returns ON. And ON-status is correct result.

4. tests/bugs/modalg_6/bug26953_3

Calls classifier for geometrically not-closed face. Before the fix, classification point was IN the face. Now, it is out (by the reason of entering of pseudo-edges).

5. tests/bugs/modalg_6/bug27341*

They are not regressions/improvements. Simply another behavior. Bug #27341 is not reproduced.

6. tests/de/iges_1/M1
   tests/de/iges_3/A5

Test contains the shape with real coincident edges (see "shape (de iges_1 M1).7z" and "shape (de iges_2 E7).7z" attached archive). Such shape is bad for classification.

7. tests/de/iges_1/O4

The reason of the correction is explained in the issue #29203.

8. tests/de/iges_1/R8

The reason of the script correction is explained in the issue #0029121.

9. tests/de/iges_2/J1
   tests/de/iges_3/B2

Source data are not valid for classification algorithm (self-intersected face like attachments faceDeI2J1.brep and FaceDeI3B2.brep).

10. tests/de/step_1/I1

Contains the face having non-manifold structure (see attached picture "de step_1 I1.PNG").

11. tests/de/step_1/J6
    tests/de/step_2/F4
    tests/de/step_2/O9

Self-intersected shape (see step_2 F4.PNG, de step_2 O9.PNG attached pictures).

12. tests/de/step_1/ZJ7

The face is really invalid (see "de step_1 ZJ7.PNG" attached picture).

13. tests/de/step_2/S1
    tests/de/step_3/D9

Since now, some faces are read with another (in compare with the MASTER) orientation (i.e. as a hole). Therefore, we obtain other isolines.

14. tests/de/step_3/A3
    tests/de/step_3/C3

Invalid (in terms of BRepCheck algorithm) face (let call it "ff") contains edge ff_4 with bending p-curve. Such faces are too hard for classification.

15. tests/bugs/moddata_2/bug299

New result is IMPROVEMENT.

16. tests/bugs/step/bug28256

The shape is really bad for classification (e.g. see message ~70970).

17. tests/heal/fix_shape/A1
    tests/heal/fix_shape/F7

Before the fix, checkshape reported "Bad orientation" about the result shape. However, indeed, the shape is oriented correctly. So the new behavior of the tests can be considered as IMPROVEMENT. On the other hand, the result shape must not be considered as valid (see issue #0023127).

18. tests/prj/base/*

New results are IMPROVEMENT.

19. tests/lowalgos/classifier/bug377

New result is IMPROVEMENT. Additionally, QA-command "OCC377" has been deleted and the test has been rewritten.

20. tests/bugs/iges/bug131_4
    tests/bugs/iges/bug131_8

Difference in the picture is expected. The source face contains really not-oriented wire (see attached pictures "bugs iges bug131_4.PNG" and "bugs iges bug131_8.PNG"). So, the source data is wrong for use in classification algorithm.

21. tests/boolean/bcut_complex/F2

Difference in the picture is expected. The reason is explained in the issue #28211 (see ~71581).

22. tests/offset/with_intersect_80/L6

The test case is BAD as before. The picture is changed only and on the FIX this picture is a bit better than on the MASTER.

23. tests/bugs/moddata_2/bug22746_3

Difference in the picture is expected. New behavior is explained in the issue #28674.

24. tests/de/step_2/M4

Difference in the picture is expected. It is not regression/improvement. Simply, another set of iso-lines.

25. tests/mesh/standard_incmesh/*
    tests/mesh/standard_incmesh_parallel/*
    tests/mesh/standard_mesh/*
    tests/mesh/standard_shading/*
    tests/bugs/vis/*
    tests/bugs/xde/bug23969
    tests/bugs/modalg_2/bug22727
    tests/bugs/modalg_2/bug21261_25
    tests/bugs/modalg_2/bug22790

Difference in the picture is expected. However, general behavior of test cases has not been changed. Therefore, it is not regressions/improvements. Changes is connected with corrections in CSLib_Class2d class (which is used by BRepMesh_Classifier directly - see method BRepMesh_Classifier::Perform()). Consequently, another set of triangles is included to the result. New behavior can be applied.

26. tests/bugs/modalg_7/bug26842_1
    tests/bugs/modalg_7/bug26842_2

Test script has been changed. Therefore, new result picture is expected.

27. tests/de/iges_1/L8

The reason of correction is explained in the issue #28211 (see ~0071639)

28. tests/bugs/modalg_6/bug27830

Regression in performance is expected. The source shape is invalid and contains the faces, which are bad for classification (this situation is described in the issue #27830 - see bug description). Moreover, it is not always clear, which status should be returned (see bugs modalg_6 bug27830.bin attached picture). As result, the current version of the classifier returns differ results in compare with the MASTER. Consequently, many lines, which are excluded from the result on the MASTER, are included in it on the FIX. So, the algorithm handles many points to build the result and of course makes it slowly.

29. tests/bugs/iges/bug16569
    tests/de/iges_1/L8
    tests/bugs/moddata_1/bug22757

Regression in performance is expected. It is connected with two factors: 1) Many classification rays are rejected by the reason that they are not valid (i.e.  only one classification ray is used on the master but the fix uses several rays for check the same face); 2) Extrema point-curve is used in the fix for check ON-status. The 1st item takes
    bugs/iges/bug16569: 92%  is taken on the 1st item and 5% on the 2nd item.
    de/iges_1/L8: 62% and 28% correspondingly

CONCLUSION: new classification algorithm works slowly than previous one with invalid cases.

30. tests/offset/wire_unclosed_outside_0_025/A8
    tests/offset/wire_unclosed_outside_0_005/A8
    tests/offset/wire_unclosed_outside_0_005/A9

Regression in performance is expected. It is connected with using UBTreeFiller which is not used on the MASTER. In the current version of classifier, it is entered in order to check whether the polygon (along the face's p-curve) is self-intersected. So, this innovative increases reliable of the classification algorithm. This criterion has greater priority than performance. Therefore, it cannot be considered as regression.

31. tests/boolean/bopcommon_complex*
    tests/boolean bopcut_complex*
    tests/bugs/modalg_6/bug26316

Some test cases from this grid requires more memory allocation. It is connected with use of UBTreeFiller. So, it is expected and is not a regression.

32. tests/bugs/modalg_7/bug29204

The reason of the correction is explained in item 3 of this commit message.
---
 src/AIS/AIS.cxx                                    |    3 +-
 src/Adaptor3d/Adaptor3d_TopolTool.cxx              |  202 +--
 src/Adaptor3d/Adaptor3d_TopolTool.hxx              |   32 +-
 src/BOPAlgo/BOPAlgo_BuilderFace.cxx                |    6 +-
 src/BOPAlgo/BOPAlgo_PaveFiller_3.cxx               |  104 +-
 src/BOPAlgo/BOPAlgo_PaveFiller_5.cxx               |   42 +-
 src/BOPAlgo/BOPAlgo_PaveFiller_6.cxx               |    4 +
 src/BOPTest/BOPTest_LowCommands.cxx                |  210 ++-
 src/BOPTools/BOPTools_AlgoTools.cxx                |    4 +
 src/BOPTools/BOPTools_AlgoTools2D.cxx              |    8 +-
 src/BOPTools/BOPTools_AlgoTools_2.cxx              |    6 +
 src/BRep/BRep_Tool.hxx                             |    2 +
 src/BRep/FILES                                     |    4 +-
 src/BRepAlgo/BRepAlgo_FaceRestrictor.cxx           |   12 +-
 src/BRepAlgo/BRepAlgo_NormalProjection.cxx         |    8 +-
 src/BRepBlend/BRepBlend_CSWalking.hxx              |    4 +-
 src/BRepBlend/BRepBlend_RstRstLineBuilder.cxx      |  227 ++-
 src/BRepBlend/BRepBlend_RstRstLineBuilder.hxx      |   17 +-
 src/BRepBlend/BRepBlend_SurfRstLineBuilder.cxx     |  211 ++-
 src/BRepBlend/BRepBlend_SurfRstLineBuilder.hxx     |    6 +-
 src/BRepBlend/BRepBlend_Walking.hxx                |   21 +-
 src/BRepBndLib/BRepBndLib.cxx                      |    9 +-
 src/BRepCheck/BRepCheck_Face.cxx                   |   12 +-
 src/BRepClass/BRepClass_Edge.cxx                   |   41 -
 src/BRepClass/BRepClass_Edge.hxx                   |   76 -
 src/BRepClass/BRepClass_Edge.lxx                   |   56 -
 src/BRepClass/BRepClass_FClass2dOfFClassifier.hxx  |   48 +-
 .../BRepClass_FClass2dOfFClassifier_0.cxx          |    5 +-
 src/BRepClass/BRepClass_FClassifier.hxx            |  115 +-
 src/BRepClass/BRepClass_FClassifier_0.cxx          |   10 +-
 src/BRepClass/BRepClass_FaceClassifier.cxx         |  462 +++++-
 src/BRepClass/BRepClass_FaceClassifier.hxx         |   63 +-
 src/BRepClass/BRepClass_FaceExplorer.cxx           |  738 +++++++--
 src/BRepClass/BRepClass_FaceExplorer.hxx           |  187 ++-
 src/BRepClass/BRepClass_FacePassiveClassifier.hxx  |  127 --
 .../BRepClass_FacePassiveClassifier_0.cxx          |   32 -
 src/BRepClass/BRepClass_Intersector.cxx            |  204 +--
 src/BRepClass/BRepClass_Intersector.hxx            |   38 +-
 src/BRepClass/FILES                                |   15 +-
 src/BRepClass3d/BRepClass3d_Intersector3d.cxx      |   21 +-
 src/BRepClass3d/BRepClass3d_Intersector3d.hxx      |   14 +-
 src/BRepClass3d/BRepClass3d_SolidExplorer.cxx      |   22 +-
 src/BRepExtrema/BRepExtrema_DistanceSS.cxx         |   38 +-
 src/BRepExtrema/BRepExtrema_ExtCF.cxx              |    4 +-
 src/BRepExtrema/BRepExtrema_ExtFF.cxx              |   20 +-
 src/BRepExtrema/BRepExtrema_ExtPF.cxx              |    5 +-
 src/BRepFeat/BRepFeat_RibSlot.cxx                  |    7 +-
 .../BRepIntCurveSurface_Inter.cxx                  |   10 +-
 .../BRepIntCurveSurface_Inter.hxx                  |    4 +-
 src/BRepLib/BRepLib_FindSurface.cxx                |    2 +-
 src/BRepLib/BRepLib_MakeFace.cxx                   |    2 +-
 src/BRepMesh/BRepMesh_Classifier.cxx               |    2 +-
 src/BRepOffset/BRepOffset_MakeOffset.cxx           |    4 +-
 src/BRepOffset/BRepOffset_Tool.cxx                 |    8 +-
 src/BRepTopAdaptor/BRepTopAdaptor_FClass2d.cxx     | 1688 ++++++++++++--------
 src/BRepTopAdaptor/BRepTopAdaptor_FClass2d.hxx     |  102 +-
 src/BRepTopAdaptor/BRepTopAdaptor_Tool.cxx         |    3 -
 src/BRepTopAdaptor/BRepTopAdaptor_TopolTool.cxx    |   27 +-
 src/BRepTopAdaptor/BRepTopAdaptor_TopolTool.hxx    |   32 +-
 src/Blend/Blend_CSWalking_1.gxx                    |   27 +-
 src/Blend/Blend_CSWalking_2.gxx                    |   18 +-
 src/Blend/Blend_CSWalking_3.gxx                    |    4 +-
 src/Blend/Blend_CSWalking_4.gxx                    |   41 +-
 src/Blend/Blend_Walking_1.gxx                      |  106 +-
 src/Blend/Blend_Walking_2.gxx                      |   17 +-
 src/Blend/Blend_Walking_3.gxx                      |   35 +-
 src/Blend/Blend_Walking_4.gxx                      |  178 +--
 src/CSLib/CSLib_Class2d.cxx                        |  585 ++++---
 src/CSLib/CSLib_Class2d.hxx                        |   99 +-
 src/ChFi3d/ChFi3d_Builder.hxx                      |   61 +-
 src/ChFi3d/ChFi3d_Builder_0.cxx                    |    8 +-
 src/ChFi3d/ChFi3d_Builder_2.cxx                    |   12 +-
 src/ChFi3d/ChFi3d_Builder_SpKP.cxx                 |    4 +-
 src/ChFi3d/ChFi3d_ChBuilder.hxx                    |    2 +-
 src/ChFi3d/ChFi3d_ChBuilder_C3.cxx                 |    2 -
 src/ChFi3d/ChFi3d_FilBuilder_C3.cxx                |    3 +-
 src/Contap/Contap_Contour.cxx                      |   61 +-
 src/Contap/Contap_Contour.hxx                      |    7 +-
 src/DsgPrs/DsgPrs_ShapeDirPresentation.cxx         |    1 -
 src/Geom2dHatch/Geom2dHatch_Classifier.hxx         |  101 +-
 src/Geom2dHatch/Geom2dHatch_Classifier_0.cxx       |    8 +-
 src/Geom2dHatch/Geom2dHatch_Elements.cxx           |  211 ++-
 src/Geom2dHatch/Geom2dHatch_Elements.hxx           |  109 +-
 .../Geom2dHatch_FClass2dOfClassifier.hxx           |   58 +-
 .../Geom2dHatch_FClass2dOfClassifier_0.cxx         |    3 -
 src/Geom2dHatch/Geom2dHatch_Hatcher.cxx            |   27 +-
 src/Geom2dHatch/Geom2dHatch_Hatcher.hxx            |    2 +-
 src/Geom2dHatch/Geom2dHatch_Intersector.cxx        |   77 +-
 src/Geom2dHatch/Geom2dHatch_Intersector.hxx        |   46 +-
 src/GeomInt/GeomInt_IntSS.cxx                      |   14 +-
 src/GeomInt/GeomInt_IntSS_1.cxx                    |   27 +-
 src/GeomInt/GeomInt_LineConstructor.cxx            |   32 +-
 src/GeomLib/GeomLib.cxx                            |   56 +-
 src/GeomLib/GeomLib.hxx                            |   10 +
 src/GeometryTest/GeometryTest_CurveCommands.cxx    |   42 +
 src/GeometryTest/GeometryTest_SurfaceCommands.cxx  |   36 +-
 src/GeomliteTest/GeomliteTest_CurveCommands.cxx    |   42 +-
 src/HLRBRep/HLRBRep_Data.cxx                       |    2 +-
 src/IntCurvesFace/IntCurvesFace_Intersector.cxx    |   15 +-
 src/IntPatch/IntPatch_ImpPrmIntersection.cxx       |   16 +-
 src/IntPatch/IntPatch_Intersection.hxx             |    9 +-
 src/IntStart/IntStart_SearchInside.gxx             |   29 +-
 src/IntTools/FILES                                 |    4 +-
 src/IntTools/IntTools.hxx                          |    2 -
 src/IntTools/IntTools_Context.cxx                  |   44 +-
 src/IntTools/IntTools_Context.hxx                  |    4 +-
 src/IntTools/IntTools_EdgeEdge.cxx                 |   14 -
 src/IntTools/IntTools_EdgeFace.cxx                 |    8 +-
 src/IntTools/IntTools_FClass2d.cxx                 |  919 -----------
 src/IntTools/IntTools_FClass2d.hxx                 |  120 --
 src/IntTools/IntTools_FaceFace.cxx                 |   32 +-
 src/IntTools/IntTools_Tools.cxx                    |   13 +-
 src/LocOpe/LocOpe_FindEdgesInFace.cxx              |   13 +-
 src/LocOpe/LocOpe_SplitShape.cxx                   |    6 +-
 src/LocOpe/LocOpe_WiresOnShape.cxx                 |    2 +-
 src/QABugs/QABugs_11.cxx                           |   91 --
 src/QABugs/QABugs_8.cxx                            |    2 +-
 .../RWStepVisual_RWPresentationLayerAssignment.cxx |    2 +-
 src/SWDRAW/SWDRAW_ShapeAnalysis.cxx                |    5 +-
 src/ShapeAnalysis/ShapeAnalysis.cxx                |    6 +-
 src/ShapeFix/ShapeFix_ComposeShell.cxx             |    4 +-
 src/ShapeFix/ShapeFix_Face.cxx                     |    8 +-
 src/TNaming/TNaming.cxx                            |   10 +-
 src/TopClass/FILES                                 |    6 +-
 src/TopClass/TopClass_Classifier2d.gxx             |   88 +-
 src/TopClass/TopClass_Classifier3d.gxx             |    2 +-
 src/TopClass/TopClass_FaceClassifier.gxx           |  293 ++--
 src/TopClass/TopClass_FaceClassifier.lxx           |   48 -
 src/TopClass/TopClass_GeomEdge.cxx                 |  247 +++
 src/TopClass/TopClass_GeomEdge.hxx                 |  230 +++
 src/TopClass/TopClass_GeomVertex.cxx               |   52 +
 src/TopClass/TopClass_GeomVertex.hxx               |  111 ++
 src/TopClass/TopClass_RayInfo.hxx                  |  164 ++
 src/TopOpeBRep/TopOpeBRep_PointClassifier.cxx      |    9 +-
 src/TopOpeBRep/TopOpeBRep_PointClassifier.hxx      |    2 +-
 .../TopOpeBRep_VPointInterClassifier.cxx           |   22 +-
 src/TopOpeBRepBuild/TopOpeBRepBuild_Builder1.cxx   |    3 +-
 src/TopOpeBRepBuild/TopOpeBRepBuild_GridSS.cxx     |    9 +-
 src/TopOpeBRepBuild/TopOpeBRepBuild_Tools.cxx      |    2 +-
 .../TopOpeBRepBuild_WireEdgeClassifier.cxx         |   40 +-
 .../TopOpeBRepBuild_WireEdgeClassifier.hxx         |    8 +-
 src/TopOpeBRepBuild/TopOpeBRepBuild_ffsfs.cxx      |    3 +-
 src/TopOpeBRepTool/TopOpeBRepTool_CLASSI.cxx       |    6 +-
 .../TopOpeBRepTool_ShapeClassifier.cxx             |  135 +-
 src/TopOpeBRepTool/TopOpeBRepTool_face.cxx         |    3 +-
 tests/blend/complex/A3                             |    3 +
 tests/blend/tolblend_simple/C1                     |    2 +
 tests/boolean/bfuse_complex/M7                     |    4 +
 tests/bugs/heal/bug22919                           |    7 +-
 tests/bugs/modalg_2/bug23341                       |   22 -
 tests/bugs/modalg_5/bug23625_2                     |    2 +-
 tests/bugs/modalg_5/bug23777                       |   22 -
 tests/bugs/modalg_5/bug23849_2                     |   23 -
 tests/bugs/modalg_5/bug24422                       |   27 -
 tests/bugs/modalg_5/bug25969                       |   37 -
 tests/bugs/modalg_5/bug25969_std                   |   37 -
 tests/bugs/modalg_6/bug25908                       |    6 +-
 tests/bugs/modalg_6/bug26206                       |   26 -
 tests/bugs/modalg_6/bug26953_3                     |    2 +-
 tests/bugs/modalg_6/bug27434                       |   21 -
 tests/bugs/modalg_6/bug28211_1                     |   25 +
 tests/bugs/modalg_6/bug28211_8                     |   24 +
 tests/bugs/modalg_6/bug28800                       |   15 +
 tests/bugs/modalg_7/bug23667                       |    2 +
 tests/bugs/modalg_7/bug26842_1                     |    9 +-
 tests/bugs/modalg_7/bug26842_2                     |   20 +-
 tests/bugs/modalg_7/bug28764                       |    3 +-
 tests/bugs/modalg_7/bug29204                       |    2 +-
 tests/bugs/moddata_1/buc60609                      |   21 -
 tests/bugs/moddata_1/bug22494                      |   27 -
 tests/bugs/moddata_2/bug22746_3                    |    2 +
 tests/bugs/moddata_2/bug23244                      |   36 -
 tests/bugs/moddata_2/bug299                        |    4 +-
 tests/bugs/moddata_2/bug377                        |   22 -
 tests/bugs/moddata_2/bug538                        |   25 -
 tests/bugs/step/bug28256                           |    6 +-
 tests/de/iges_2/C5                                 |    1 +
 tests/de/iges_2/G7                                 |    2 +-
 tests/de/iges_2/H4                                 |    1 +
 tests/de/iges_3/A1                                 |    1 +
 tests/de/step_3/E6                                 |    1 +
 tests/heal/fix_shape/A1                            |   11 +-
 tests/heal/fix_shape/F7                            |   11 +-
 tests/heal/surface_to_bspline/F2                   |    2 +-
 tests/lowalgos/classifier/buc60609                 |   21 +
 tests/lowalgos/classifier/bug22494                 |   26 +
 tests/lowalgos/classifier/bug23244                 |   36 +
 tests/lowalgos/classifier/bug23341                 |   21 +
 tests/lowalgos/classifier/bug23777                 |   22 +
 tests/lowalgos/classifier/bug23849_2               |   23 +
 tests/lowalgos/classifier/bug24422                 |   25 +
 tests/lowalgos/classifier/bug25969                 |   37 +
 tests/lowalgos/classifier/bug25969_std             |   37 +
 tests/lowalgos/classifier/bug26206                 |   26 +
 tests/lowalgos/classifier/bug27434                 |   21 +
 tests/lowalgos/classifier/bug28211_10              |   36 +
 tests/lowalgos/classifier/bug28211_11              |   37 +
 tests/lowalgos/classifier/bug28211_12              |   49 +
 tests/lowalgos/classifier/bug28211_13              |   34 +
 tests/lowalgos/classifier/bug28211_14              |   47 +
 tests/lowalgos/classifier/bug28211_15              |   35 +
 tests/lowalgos/classifier/bug28211_16              |   35 +
 tests/lowalgos/classifier/bug28211_17              |   29 +
 tests/lowalgos/classifier/bug28211_18              |   60 +
 tests/lowalgos/classifier/bug28211_19              |   39 +
 tests/lowalgos/classifier/bug28211_2               |   69 +
 tests/lowalgos/classifier/bug28211_20              |   43 +
 tests/lowalgos/classifier/bug28211_21              |   43 +
 tests/lowalgos/classifier/bug28211_22              |   38 +
 tests/lowalgos/classifier/bug28211_23              |   30 +
 tests/lowalgos/classifier/bug28211_24              |   41 +
 tests/lowalgos/classifier/bug28211_25              |   42 +
 tests/lowalgos/classifier/bug28211_26              |   42 +
 tests/lowalgos/classifier/bug28211_27              |   50 +
 tests/lowalgos/classifier/bug28211_28              |   37 +
 tests/lowalgos/classifier/bug28211_29              |  116 ++
 tests/lowalgos/classifier/bug28211_3               |   69 +
 tests/lowalgos/classifier/bug28211_30              |   34 +
 tests/lowalgos/classifier/bug28211_31              |   38 +
 tests/lowalgos/classifier/bug28211_32              |   61 +
 tests/lowalgos/classifier/bug28211_33              |   50 +
 tests/lowalgos/classifier/bug28211_34              |   62 +
 tests/lowalgos/classifier/bug28211_35              |   60 +
 tests/lowalgos/classifier/bug28211_36              |   54 +
 tests/lowalgos/classifier/bug28211_37              |   50 +
 tests/lowalgos/classifier/bug28211_38              |   50 +
 tests/lowalgos/classifier/bug28211_39              |   62 +
 tests/lowalgos/classifier/bug28211_4               |   69 +
 tests/lowalgos/classifier/bug28211_40              |   49 +
 tests/lowalgos/classifier/bug28211_5               |   69 +
 tests/lowalgos/classifier/bug28211_6               |   36 +
 tests/lowalgos/classifier/bug28211_7               |   60 +
 tests/lowalgos/classifier/bug28211_9               |   29 +
 tests/lowalgos/classifier/bug29203_1               |   34 +
 tests/lowalgos/classifier/bug29203_2               |   36 +
 tests/lowalgos/classifier/bug377                   |   99 ++
 tests/lowalgos/classifier/bug538                   |   43 +
 tests/lowalgos/grids.list                          |    3 +-
 tests/lowalgos/parse.rules                         |    2 +
 tests/sewing/tol_100/K1                            |    1 -
 240 files changed, 7905 insertions(+), 5397 deletions(-)
 delete mode 100644 src/BRepClass/BRepClass_Edge.cxx
 delete mode 100644 src/BRepClass/BRepClass_Edge.hxx
 delete mode 100644 src/BRepClass/BRepClass_Edge.lxx
 delete mode 100644 src/BRepClass/BRepClass_FacePassiveClassifier.hxx
 delete mode 100644 src/BRepClass/BRepClass_FacePassiveClassifier_0.cxx
 delete mode 100644 src/IntTools/IntTools_FClass2d.cxx
 delete mode 100644 src/IntTools/IntTools_FClass2d.hxx
 delete mode 100644 src/TopClass/TopClass_FaceClassifier.lxx
 create mode 100644 src/TopClass/TopClass_GeomEdge.cxx
 create mode 100644 src/TopClass/TopClass_GeomEdge.hxx
 create mode 100644 src/TopClass/TopClass_GeomVertex.cxx
 create mode 100644 src/TopClass/TopClass_GeomVertex.hxx
 create mode 100644 src/TopClass/TopClass_RayInfo.hxx
 delete mode 100755 tests/bugs/modalg_2/bug23341
 delete mode 100755 tests/bugs/modalg_5/bug23777
 delete mode 100644 tests/bugs/modalg_5/bug23849_2
 delete mode 100644 tests/bugs/modalg_5/bug24422
 delete mode 100644 tests/bugs/modalg_5/bug25969
 delete mode 100644 tests/bugs/modalg_5/bug25969_std
 delete mode 100644 tests/bugs/modalg_6/bug26206
 delete mode 100644 tests/bugs/modalg_6/bug27434
 create mode 100644 tests/bugs/modalg_6/bug28211_1
 create mode 100644 tests/bugs/modalg_6/bug28211_8
 create mode 100644 tests/bugs/modalg_6/bug28800
 delete mode 100755 tests/bugs/moddata_1/buc60609
 delete mode 100755 tests/bugs/moddata_1/bug22494
 delete mode 100755 tests/bugs/moddata_2/bug23244
 delete mode 100755 tests/bugs/moddata_2/bug377
 delete mode 100755 tests/bugs/moddata_2/bug538
 create mode 100644 tests/lowalgos/classifier/buc60609
 create mode 100644 tests/lowalgos/classifier/bug22494
 create mode 100644 tests/lowalgos/classifier/bug23244
 create mode 100644 tests/lowalgos/classifier/bug23341
 create mode 100644 tests/lowalgos/classifier/bug23777
 create mode 100644 tests/lowalgos/classifier/bug23849_2
 create mode 100644 tests/lowalgos/classifier/bug24422
 create mode 100644 tests/lowalgos/classifier/bug25969
 create mode 100644 tests/lowalgos/classifier/bug25969_std
 create mode 100644 tests/lowalgos/classifier/bug26206
 create mode 100644 tests/lowalgos/classifier/bug27434
 create mode 100644 tests/lowalgos/classifier/bug28211_10
 create mode 100644 tests/lowalgos/classifier/bug28211_11
 create mode 100644 tests/lowalgos/classifier/bug28211_12
 create mode 100644 tests/lowalgos/classifier/bug28211_13
 create mode 100644 tests/lowalgos/classifier/bug28211_14
 create mode 100644 tests/lowalgos/classifier/bug28211_15
 create mode 100644 tests/lowalgos/classifier/bug28211_16
 create mode 100644 tests/lowalgos/classifier/bug28211_17
 create mode 100644 tests/lowalgos/classifier/bug28211_18
 create mode 100644 tests/lowalgos/classifier/bug28211_19
 create mode 100644 tests/lowalgos/classifier/bug28211_2
 create mode 100644 tests/lowalgos/classifier/bug28211_20
 create mode 100644 tests/lowalgos/classifier/bug28211_21
 create mode 100644 tests/lowalgos/classifier/bug28211_22
 create mode 100644 tests/lowalgos/classifier/bug28211_23
 create mode 100644 tests/lowalgos/classifier/bug28211_24
 create mode 100644 tests/lowalgos/classifier/bug28211_25
 create mode 100644 tests/lowalgos/classifier/bug28211_26
 create mode 100644 tests/lowalgos/classifier/bug28211_27
 create mode 100644 tests/lowalgos/classifier/bug28211_28
 create mode 100644 tests/lowalgos/classifier/bug28211_29
 create mode 100644 tests/lowalgos/classifier/bug28211_3
 create mode 100644 tests/lowalgos/classifier/bug28211_30
 create mode 100644 tests/lowalgos/classifier/bug28211_31
 create mode 100644 tests/lowalgos/classifier/bug28211_32
 create mode 100644 tests/lowalgos/classifier/bug28211_33
 create mode 100644 tests/lowalgos/classifier/bug28211_34
 create mode 100644 tests/lowalgos/classifier/bug28211_35
 create mode 100644 tests/lowalgos/classifier/bug28211_36
 create mode 100644 tests/lowalgos/classifier/bug28211_37
 create mode 100644 tests/lowalgos/classifier/bug28211_38
 create mode 100644 tests/lowalgos/classifier/bug28211_39
 create mode 100644 tests/lowalgos/classifier/bug28211_4
 create mode 100644 tests/lowalgos/classifier/bug28211_40
 create mode 100644 tests/lowalgos/classifier/bug28211_5
 create mode 100644 tests/lowalgos/classifier/bug28211_6
 create mode 100644 tests/lowalgos/classifier/bug28211_7
 create mode 100644 tests/lowalgos/classifier/bug28211_9
 create mode 100644 tests/lowalgos/classifier/bug29203_1
 create mode 100644 tests/lowalgos/classifier/bug29203_2
 create mode 100644 tests/lowalgos/classifier/bug377
 create mode 100644 tests/lowalgos/classifier/bug538

diff --git a/src/AIS/AIS.cxx b/src/AIS/AIS.cxx
index 60b6067..95203a1 100644
--- a/src/AIS/AIS.cxx
+++ b/src/AIS/AIS.cxx
@@ -1221,8 +1221,7 @@ void AIS::InitLengthBetweenCurvilinearFaces (const TopoDS_Face&    theFirstFace,
     // Now there is projection of FirstAttach onto SecondSurf in aProjector
     BRepTopAdaptor_FClass2d aClassifier (theSecondFace, Precision::Confusion());
 
-    TopAbs_State aState = 
-      aClassifier.Perform (gp_Pnt2d (aPU, aPV), theSecondSurf->IsUPeriodic() || theSecondSurf->IsVPeriodic());
+    TopAbs_State aState = aClassifier.Perform (gp_Pnt2d (aPU, aPV), Standard_True);
 
     if (aState == TopAbs_OUT || aState == TopAbs_UNKNOWN)
     {
